// Global variables
var journalID, etapeID, memberID, journalFields, depthLimit, versionNumber = "V1.04";
var currentJournal, currentEtape, etapeID, journalID, screenChoice, tableRows = 0,
	bateau, allEtapes = [],
	journal = [], teamMember = [],
	tabStr = String.fromCharCode(9),
	rowStr = String.fromCharCode(8),
	sepStr = String.fromCharCode(7);

// Informations du navire 
var vesselName, vesselType, regNumber, mmsi, callSign, vesselLength, vesselWidth, vesselDraft, vesselWeight, navZone, homeport, navTitle, frenchizationAct, vesselModele, vesselConstructeur, constructionDate, francisationNumber, vesselMotor, conceptionCat, cinNumber, policeName, policeNumber, shipStationLicenseNumber, shipStationLicenseValidUntil, policeValidUntil;

// Étapes
var refStepJournal, stepDate, stepTime, pressureStep, seaStep, windDirStep, windForceStep, captain, orig, latOrig, longOrig, dest, latDest, longDest, stepDescr, memberCount, mb = [-1, -1, -1, -1, -1, -1];

// Journal
var numID, refJournalStep, dateJournal, timeJournal, timeOffsetH, timeOffsetM, forecastJournal, hygrometryJournal, pressureJournal, skyJournal, visibilityJournal, precipitationJournal, seaJournal, windDirJournal, windForceJournal, windGustsJournal, tempAirJournal, tempWaterJournal, depthJournal, lochSpeedJournal, realSpeedJournal, compasCourseJournal,
	trueCourseJournal, latJournal, longJournal, motorJournal, waterJournal, gasJournal, motorBatteryJournal, batteriesJournal, remarksJournal;

// Équipage
var memberNummerID, memberFirst, memberLast, memberPseudo, memberSex, memberBirthday, memberCountry, memberEmail, memberRemark;

// Arrays
var visibilityChoice = ["", "nulle", "mauvaise", "faible", "moyenne", "bonne", "excellente"];
var seaChoice = ["", "calme", "belle", "agitée", "très agitée", "creuse", "forte", "très forte", "énorme"];
var navChoice = ["", "Basique (jusqu'à 2 milles)", "Côtier (de 2 à 6 milles)", "Semi-hauturier (de 6 à 60 milles)", "Hauturier (au-delà de 60 milles)"];
var precipitationChoice = ["aucune", "bruine", "pluie", "pluie intense", "grésil", "grêle", "grêle importante", "neige", "neige intense"];
var conceptionChoice = ["", "A) Force 9 (47-61 nœuds) - Vagues 10 m", "B) Force 8 (40-52 nœuds) - Vagues 8 m", "C) Force 6 (27-35 nœuds) - Vagues 4 m", "D) Force 4 (16-23 nœuds) - Vagues 0.5 m"];

function addPeople(elem1, elem2) {
	var member = "member" + elem1;
    var m = document.getElementById(member);
	//debugger;
	if (m.value != -1) {
		var table = "table" + elem2;
    	var t = document.getElementById(table);
		var button = "b" + elem2;
    	var b = document.getElementById(button);
		t.style.display = "block";
		b.style.display = "block";
		button = "b" + elem1;
		b = document.getElementById(button);
		b.style.display = "none";
	}
}

function getMemberValues(index) {
	//debugger;
	var thisMember = teamMember[index];
	var infoArray = thisMember.split(tabStr);
	memberNummerID = infoArray[0];
	memberFirst = infoArray[1];
	memberLast = infoArray[2];
	memberPseudo = infoArray[3];
	memberSex = infoArray[4];
	memberBirthday = infoArray[5];
	memberCountry = infoArray[6];
	memberEmail = infoArray[7];
	memberRemark = infoArray[8];
}

function getEtapeValues(index) {
	//debugger;
	var thisEtape = allEtapes[index];
	var infoArray = thisEtape.split(tabStr);
	refStepJournal = infoArray[0];
	stepDate = infoArray[1];
	stepTime = infoArray[2];
	pressureStep = infoArray[3];
	seaStep = infoArray[4];
	windDirStep = infoArray[5];
	windForceStep = infoArray[6];
	captain = infoArray[7];
	orig = infoArray[8];
	latOrig = infoArray[9];
	longOrig = infoArray[10];
	dest = infoArray[11];
	latDest = infoArray[12];
	longDest = infoArray[13];
	stepDescr = infoArray[14];
	memberCount = infoArray[15];
	mb = [-1, -1, -1, -1, -1, -1];
	//debugger;
	if (memberCount > 0) {
		var f;
		for (f = 0; f < memberCount; ++f) {
			mb[f] = infoArray[16 + f];
		}
	//debugger;
	}
}

function getJournalValues(index) {
	//debugger;
	var thisJournal = journal[index];
	var infoArray = thisJournal.split(tabStr);
	numID = infoArray[0];
	refJournalStep = infoArray[1];
	dateJournal = infoArray[2];
	timeJournal = infoArray[3];
	timeOffsetH = infoArray[4];
	timeOffsetM = infoArray[5];
	hygrometryJournal = infoArray[6];
	pressureJournal = infoArray[7];
	skyJournal = infoArray[8];
	visibilityJournal = infoArray[9];
	precipitationJournal = infoArray[10];
	seaJournal = infoArray[11];
	windDirJournal = infoArray[12];
	windForceJournal = infoArray[13];
	windGustsJournal = infoArray[14];
	tempAirJournal = infoArray[15];
	tempWaterJournal = infoArray[16];
	depthJournal = infoArray[17];
	lochSpeedJournal = infoArray[18];
	realSpeedJournal = infoArray[19];
	compasCourseJournal = infoArray[20];
	trueCourseJournal = infoArray[21];
	latJournal = infoArray[22];
	longJournal = infoArray[23];
	motorJournal = infoArray[24];
	waterJournal = infoArray[25];
	gasJournal = infoArray[26];
	motorBatteryJournal = infoArray[27];
	batteriesJournal = infoArray[28];
	remarksJournal = infoArray[29];
	forecastJournal = infoArray[30];
}

function getBateauValues() {
	//debugger;
	if (bateau == null) {
		return;
	}
	var infoArray = bateau.split(tabStr);
	vesselName = infoArray[0];
	vesselType = infoArray[1];
	regNumber = infoArray[2];
	mmsi = infoArray[3];
	callSign = infoArray[4];
	vesselLength = infoArray[5];
	vesselWidth = infoArray[6];
	vesselDraft = infoArray[7];
	vesselWeight = infoArray[8];
	navZone = infoArray[9];
	homeport = infoArray[10];
	navTitle = infoArray[11];
	frenchizationAct = infoArray[12];
	vesselModele = infoArray[13];
	vesselConstructeur = infoArray[14];
	constructionDate = infoArray[15];
	francisationNumber = infoArray[16];
	vesselMotor = infoArray[17];
	conceptionCat = infoArray[18];
	cinNumber = infoArray[19];
	policeName = infoArray[20];
	policeNumber = infoArray[21];
	shipStationLicenseNumber = infoArray[22];
	shipStationLicenseValidUntil = infoArray[23];
	policeValidUntil = infoArray[24];
}

function initPeople () {
	//debugger;
	var b, button, count, t, table;
	for (count=2; count<7; ++count) {
		table = "table" + count;
		t = document.getElementById(table);
		button = "b" + count;
		b = document.getElementById(button);
		t.style.display = "none";
		b.style.display = "none";
	}
}

function previousEtape() {
	//debugger;
	// visuDisplayBateau();
	if (currentEtape > 0) {
		visuDisplayEtape(--currentEtape);
		visuDisplayJournal(currentEtape);
	}
}

function startEtape() {
	currentEtape = 0;
	visuDisplayEtape(currentEtape);
	visuDisplayJournal(currentEtape);
}

function endEtape() {
	currentEtape = etapeID;
	visuDisplayEtape(currentEtape);
	visuDisplayJournal(currentEtape);
}

function editMember() {
	//debugger;
	var memberNum = document.getElementById("memberEdit").value;
	if (memberNum == -1) {
		document.getElementById("memberNummerID").value = "";
		document.getElementById("memberFirst").value = "";
		document.getElementById("memberLast").value = "";
		document.getElementById("memberPseudo").value = "";
		document.getElementById("memberSex").value = "";
		document.getElementById("memberBirthday").value = "";
		document.getElementById("memberCountry").value = "";
		document.getElementById("memberEmail").value = "";
		document.getElementById("memberRemark").value = "";
	} else {
		getMemberValues(memberNum);
		document.getElementById("memberNummerID").value = memberNummerID;
		document.getElementById("memberFirst").value = memberFirst;
		document.getElementById("memberLast").value = memberLast;
		document.getElementById("memberPseudo").value = memberPseudo;
		document.getElementById("memberSex").value = memberSex;
		document.getElementById("memberBirthday").value = memberBirthday;
		document.getElementById("memberCountry").value = memberCountry;
		document.getElementById("memberEmail").value = memberEmail;
		document.getElementById("memberRemark").value = memberRemark;
	}
}

function followingEtape() {
	//debugger;
	// visuDisplayBateau();
	if (currentEtape < etapeID) {
		visuDisplayEtape(++currentEtape);
		visuDisplayJournal(currentEtape);
	}
}

function dms2Dec(latOrLong) {
	var deg, min, sec, dir;
	if (latOrLong.length == 11) { // 009-17-49 E (longitude)
		deg = parseInt(latOrLong.slice(0, 3));
		min = parseInt(latOrLong.slice(4, 6));
		sec = parseInt(latOrLong.slice(7, 9));
		if (latOrLong.slice(10, 11) == "O") {
			dir = -1;
		} else {
			dir = 1;
		}
	} else if (latOrLong.length == 10) { // 51-04-26 N (latitude)
		deg = parseInt(latOrLong.slice(0, 2));
		min = parseInt(latOrLong.slice(3, 5));
		sec = parseInt(latOrLong.slice(6, 8));
		if (latOrLong.slice(9, 10) == "S") {
			dir = -1;
		} else {
			dir = 1;
		}
	}
	//debugger;
	return (deg + min / 60 + sec / 3600) * dir;
}

function deg2Rad(degrees) {
	return degrees * (Math.PI / 180);
}

function orthodromy(lat1, long1, lat2, long2) {
	if (lat1 == lat2 && long1 == long2) {
		return 0;
	}
	var rLat1 = deg2Rad(lat1),
		rLat2 = deg2Rad(lat2)
		//debugger;
	return Math.acos(Math.sin(rLat1) * Math.sin(rLat2) + Math.cos(rLat1) * Math.cos(rLat2) * Math.cos(deg2Rad(long1 - long2))) * 3440;
}

function visuDisplayBateau() {
	var tStr, tmpStr = "<div class='tooltip'>Nom du navire : «&nbsp;<strong>" + vesselName + "</strong>&nbsp;»<span class='tooltiptext'><table width='600px'>";
	tmpStr += "<tr><td>Type / Modèle / Constructeur :</td><td>" + vesselModele + " / "+ vesselType + " / "+ vesselConstructeur +"</td></tr>";
	tmpStr += "<tr><td>Long. / Larg. / Tir. d'eau / Dépl. / Nb de moteurs :</td><td>" + vesselLength + " m / " + vesselWidth + " m / " + vesselDraft + " m / " + vesselWeight + " / "+ vesselMotor + "</td></tr>";
	tmpStr += "<tr><td>Port d'attache / N° d'immatriculation :</td><td>«&nbsp;"  + homeport + "&nbsp;» / «&nbsp;" + regNumber + "&nbsp;»</td></tr>";
	tStr = formatDate(frenchizationAct);
	tmpStr += "<tr><td>Acte de francisation N° :</td><td>«&nbsp;" + francisationNumber + "&nbsp;» délivré le " + tStr + "</td></tr>";
	tStr = formatDate(shipStationLicenseValidUntil);
	tmpStr += "<tr><td>Licence de station de navire N° :</td><td>«&nbsp;" + shipStationLicenseNumber + "&nbsp;» valable jusqu'au " + tStr + "</td></tr>";
	tmpStr += "<tr><td>MMSI / Indicatif d'appel VHF :</td><td>«&nbsp;" + mmsi + "&nbsp;» / «&nbsp;" + callSign +  "&nbsp;»</td></tr>";
	tmpStr += "<tr><td>Équipé pour une navigation de type :</td><td>" + navChoice[navZone] + "</td></tr>";
	tmpStr += "<tr><td>Catégorie de conception :</td><td>" + conceptionChoice[conceptionCat] + "</td></tr>";
	tStr = formatDate(policeValidUntil);
	tmpStr += "<tr><td>Assurance :</td><td> (" + policeName + ") N° " + policeNumber + " valable jusqu'au " + tStr + "</td></tr></span></table>";
	document.getElementById("visuInfoBateau").innerHTML = tmpStr
}

function formatDate(date) {
	return date.substring(8, 10) + "/" + date.substring(5, 7) + "/" + date.substring(0, 4);
}

function visuDisplayEtape(stepID) {
	var people;
	var newDate = "";
	if (stepID == -1) {
		currentEtape = etapeID;
	} else {
		currentEtape = stepID;
	}
	// debugger;
	getEtapeValues(currentEtape);
	getMemberValues (captain);
	people = memberFirst + "&nbsp;" + memberLast + " (chef de bord)";
	if (memberCount > 0) {
		var f;
		for (f = 0; f < memberCount; ++f) {
			getMemberValues (mb[f]);
			people += ", " + memberFirst + "&nbsp;" + memberLast
		}
	}
	newDate = formatDate(stepDate);
	var tmpStr = "<div class='tooltip'>Étape <strong> " + orig + " -> " + dest + "</strong> commençant le " + newDate + " à " + stepTime + ". À bord : " + people + ".<span class='tooltiptext'>Pression atmosphérique : " + pressureStep + " hPa,<br>État de la mer :" + seaChoice[seaStep] + ",<br>Direction du vent : " + windDirStep + " °,<br>Vitesse du vent :" + windForceStep + " nœuds</span></div>";
	document.getElementById("visuInfoEtape").innerHTML = tmpStr;
	document.getElementById("infoEtapeJournal").innerHTML = tmpStr;
}

function visuDisplayJournal(stepID) {
	var f, firstDate, previousDate, firstTime, previousTime, firstLat, previousLat, firstLong, previousLong, totalDays;
	var orthodromie, minutesBefore24, minutesAfter24, minutes, hours, mins, timeStr, newDate, tooltipText, speed, windInfo;
	var reportMiles = 0,
		totalMiles = 0,
		dayMiles = 0,
		totalMinutes = 0,
		dayMinutes = 0;
	currentEtape = stepID;
	// Remove all previous rows
	//debugger;
	for (f = 0; f < tableRows; ++f) {
		visuTable.removeChild(visuTable.childNodes[0]);
	}
	// Table header
	visuTable.insertAdjacentHTML('beforeend', "<tr class='tooltip'><th width='110px'>Date &amp; Heure TU</th><th width='155px'>Position</th><th width='36px'>Milles</th><th width='28px'>Cap vrai</th><th width='440px'>Remarques</th></tr>");
	tableRows = 1;
	// Find last logbook input having the same currentEtape
	currentJournal = journalID;
	do {
		getJournalValues(currentJournal);
		if (refJournalStep == currentEtape) {
			break;
		}
	} while (--currentJournal > -1);
	if (currentJournal == -1) {
		return;
	}
	// Find first logbook input having the same currentEtape
	do {
		if (--currentJournal == -1) {
			break;
		}
		getJournalValues(currentJournal);
	} while (refJournalStep == currentEtape);
	if (currentJournal == -1) {
		++currentJournal;
	} else { ++currentJournal; }
	getEtapeValues(stepID);
	getJournalValues(currentJournal); // First journal entry using currentEtape
	firstDate = dateJournal; // all variables starting with "first" refer to the first journal entry of the etape
	firstTime = timeJournal;
	previousDate = dateJournal; // all variables starting with "previous" refer to the last journal entry
	previousTime = stepTime; // timeJournal;
	previousLat = latOrig; // latJournal;
	previousLong = longOrig; // longJournal;
	firstLat = latJournal;
	firstLong = longJournal;
	totalDays = 1;
	tooltipText = "Pression atmosphérique : " + pressureStep + " hPa,<br>État de la mer :" + seaChoice[seaStep] + ",<br>Direction du vent : " + windDirStep + " °,<br>Vitesse du vent :" + windForceStep + " nœuds";
	newDate = formatDate(dateJournal);
	visuTable.insertAdjacentHTML('beforeend', "<tr class='tooltip'><td width='107px'>" + newDate + " " + stepTime + "</td><td width='158px'>" + latOrig + "&nbsp;" + longOrig + "</td><td width='38px'>&nbsp;</td><td width='30px'>&nbsp;</td><td width='440px'> Départ de " + orig + "<span class='tooltiptext'>" + tooltipText + "</span></td></tr>");
	++tableRows;

	do {
		//debugger;
		if (currentJournal > journalID) {
			if (dayMiles > 0) {
				speed = dayMiles / (dayMinutes / 60);
				hours = Math.floor(dayMinutes / 60);
				mins = dayMinutes - hours * 60;
				timeStr = hours + " h";
				if (mins > 0) {
					timeStr = timeStr + " " + mins + " m";
				}
				newDate = formatDate(previousDate);
				visuTable.insertAdjacentHTML('beforeend', "<tr><td colspan='5'><strong>Total du " + newDate + "</strong> : " + Math.round(dayMiles) + " milles " + " à la vitesse moyenne de " + speed.toFixed(1) + " nœuds (" + timeStr + ")</td></tr>");
				++tableRows;
			}
			break;
		}
		getJournalValues(currentJournal);
		if (previousDate != dateJournal) { // if date changed then display total of the day
			orthodromie = orthodromy(dms2Dec(previousLat), dms2Dec(previousLong), dms2Dec(latJournal), dms2Dec(longJournal));
			minutesBefore24 = numberOfMinutes(previousTime, "00:00");
			minutesAfter24 = numberOfMinutes("00:00", timeJournal);
			minutes = minutesBefore24 + minutesAfter24;
			milesBefore24 = orthodromie / minutes * minutesBefore24;
			//debugger;
			if (refJournalStep == currentEtape) {
				dayMiles = dayMiles + milesBefore24;
				dayMinutes = dayMinutes + minutesBefore24; ///////
			} else {
				milesBefore24 = 0;
				//dayMiles = 0;
			}
			//totalMiles = totalMiles + dayMiles;
			//totalMinutes = totalMinutes + dayMinutes;
			speed = dayMiles / (dayMinutes / 60);
			hours = Math.floor(dayMinutes / 60);
			mins = dayMinutes - hours * 60;
			timeStr = hours + " h";
			if (mins > 0) {
				timeStr = timeStr + " " + mins + " m";
			}
			newDate = formatDate(previousDate);
			if (milesBefore24 > 0) {
				tmpStr = " (avec environ " + Math.round(milesBefore24) + " milles jusqu'à minuit)";
			} else {
				tmpStr = "";
			}
			//debugger;
			visuTable.insertAdjacentHTML('beforeend', "<tr><td colspan='5'><strong>Total du " + newDate + "</strong> : " + Math.round(dayMiles) + " milles " + tmpStr + " à la vitesse moyenne de " + speed.toFixed(1) + " nœuds (" + timeStr + ")</td></tr>");
			totalMiles = totalMiles + dayMiles;
			totalMinutes = totalMinutes + dayMinutes;
			//debugger;
			++tableRows;
			++totalDays;
			reportMiles = orthodromie / minutes * minutesAfter24;
			dayMinutes = 0;
			dayMiles = 0;
		}
		if (refJournalStep != currentEtape) {
			break;
		}

		if (reportMiles > 0) {
			orthodromie = reportMiles;
			reportMiles = 0;
			minutes = minutesAfter24;
		} else {
			orthodromie = orthodromy(dms2Dec(previousLat), dms2Dec(previousLong), dms2Dec(latJournal), dms2Dec(longJournal));
			if (tableRows > 1) {
				//debugger;
				minutes = numberOfMinutes(previousTime, timeJournal);
			} else {
				minutes = 0;
			}
		}

		dayMiles = dayMiles + orthodromie;
		dayMinutes = dayMinutes + minutes;
		newDate = formatDate(dateJournal);
		//debugger;
		
		if (windGustsJournal != "") { windInfo = windForceJournal + " / " + windGustsJournal + " nœuds"; }
		else { windInfo = windForceJournal + " nœuds"; }
		// Insert 1 row for each logbook entry
		if (depthJournal != "") { timeStr = depthJournal; }
		else { timeStr = ">" + depthLimit; }
		tooltipText = "<table id='ttt' width='560'><tr><td>Pression atm. : " + pressureJournal + " hPa</td><td>Couverture du ciel : " + skyJournal + "</td><td>Visibilité : " + visibilityChoice[visibilityJournal] + "</td></tr><tr><td>Direction du vent : " + windDirJournal + "°</td><td>Vitesse du vent : " + windInfo + "</td><td>Précipitations : " + precipitationChoice[precipitationJournal] + ", hygro : " + hygrometryJournal + "%" + "</td></tr><tr><td>Mer : " + seaChoice[seaJournal] + "</td><td>Température air : " + tempAirJournal + "° C.</td><td>Température eau : " + tempWaterJournal + "° C.</td></tr><tr><td>Profondeur : " + timeStr + " mètres</td><td>Vitesse loch : " + lochSpeedJournal + " nœuds</td><td>Vitesse vraie : " + realSpeedJournal + " nœuds</td></tr><tr><td>Cap compas : " + compasCourseJournal + "°</td><td>Utilisation moteur : " + motorJournal + "</td><td>Décalage horaire : " + timeOffsetH + ":" + timeOffsetM + "</td></tr><tr><td>Quantité d'eau : " + waterJournal + " litres</td><td>Quantité de gasoil : " + gasJournal + " litres</td><td>Tension batteries : " + motorBatteryJournal + "(M) / " + batteriesJournal + "(S) volt</td></tr></table>";

		visuTable.insertAdjacentHTML('beforeend', "<tr class='tooltip'><td width='107px'>" + newDate + " " + timeJournal + "<span class='tooltiptext'>" + tooltipText + "</span></td><td width='158px'>" + latJournal + "&nbsp;" + longJournal + "</td><td width='38px'>" + Math.round(orthodromie) + "</td><td width='30px'>" + trueCourseJournal + "</td><td width='440px'>" + remarksJournal + "</td></tr>");
		//totalMiles = totalMiles + dayMiles;
		//totalMinutes = totalMinutes + dayMinutes;
		//debugger;
		++tableRows;
		++currentJournal;
		previousDate = dateJournal; // all variables starting with "previous" refer to the last journal entry
		previousTime = timeJournal;
		previousLat = latJournal;
		previousLong = longJournal;
	} while (refJournalStep == currentEtape);
	//debugger;
	totalMinutes += dayMinutes;
	totalMiles += dayMiles;
	if (totalDays > 1) {
		speed = totalMiles / (totalMinutes / 60);
		hours = Math.floor(totalMinutes / 60);
		mins = dayMinutes - hours * 60;
		timeStr = hours + " h";
		if (mins > 0) {
			timeStr = timeStr + " " + mins + " m";
		}
		visuTable.insertAdjacentHTML('beforeend', "<tr><td colspan='5'><strong>Distance totale parcourue</strong> (depuis " + orig + ") : " + Math.round(totalMiles) + " milles à la vitesse moyenne de " + speed.toFixed(1) + " nœuds (" + timeStr + ")</td></tr>");
		++tableRows;
	}
	orthodromie = orthodromy(dms2Dec(latJournal), dms2Dec(longJournal), dms2Dec(firstLat), dms2Dec(firstLong));
	if (orthodromie != 0) {
		//timeStr = timeString(orthodromie / speed * 60);
		visuTable.insertAdjacentHTML('beforeend', "<tr><td colspan='5'><strong>Distance réellement parcourue</strong> (à vol d'oiseau) : " + Math.round(orthodromie) + " milles (entre " + orig + " et la position actuelle).</td></tr>");
		++tableRows;
	}
	//debugger;
	orthodromie = orthodromy(dms2Dec(latJournal), dms2Dec(longJournal), dms2Dec(latDest), dms2Dec(longDest));
	if (orthodromie != 0) {
		if (dayMiles != 0 && dayMinutes != 0) {
			speed = dayMiles / (dayMinutes / 60);
			var minutesToDest = orthodromie / speed * 60;
			//debugger;
			timeStr = timeString(minutesToDest);
			var ndt = newDateTime (dateJournal, timeJournal, minutesToDest);
			visuTable.insertAdjacentHTML('beforeend', "<tr><td colspan='5'><strong>Distance restante à parcourir</strong> (à vol d'oiseau) : " + Math.round(orthodromie) + " milles (entre la position actuelle et " + dest + ") soit" + timeStr + ndt + ".</td></tr>");
			++tableRows;
		}
	}
}

function newDateTime (date, time, addMinutes) {
	var day = parseInt(date.substring(8, 10)), 
		month = parseInt(date.substring(5, 7)) - 1,
		year = parseInt(date.substring(0, 4)),
		hours = parseInt(time.substring(0, 2)),
		minutes = parseInt(time.substring(3, 5)),
		//dateTime = new Date(Date.UTC(year, month, day, hours, minutes, 0, 0)),
		dateTime = new Date(year, month, day, hours, minutes, 0, 0),
		retDateTime;
	//debugger;
	dateTime.setMinutes(dateTime.getMinutes() + addMinutes);
	day = dateTime.getDate();
	month = dateTime.getMonth() + 1;
	year = dateTime.getFullYear();
	hours = dateTime.getHours();
	minutes = dateTime.getMinutes();
	if (day < 10) { retDateTime = "0" + day + "/"; }
	else { retDateTime = day + "/"; }
	if (month < 10) { retDateTime += "0" + month + "/"; }
	else { retDateTime += month + "/"; }
	retDateTime += year + " vers ";
	if (minutes < 8) {
		retDateTime += hours + "h";
	} else if (minutes < 23) {
		retDateTime += hours + "h15";
	} else if (minutes < 38) {
		retDateTime += hours + "h30";
	} else if (minutes < 53) {
		retDateTime += hours + "h45";
	} else {
		retDateTime += ++hours + "h00";
	}
	return retDateTime;
}

function timeString(totalMinutes) {
	//debugger;
	var days = Math.floor(totalMinutes / 1440);
	var minutes = totalMinutes - days * 1440;
	var hours = Math.floor(minutes / 60);
	var tmpStr = "";
	minutes = minutes - hours * 60;
	if (days > 0) {
		tmpStr = " " + days + " jour";
		if (days > 1) {
			tmpStr = tmpStr + "s";
		}
	}
	if (hours > 0) {
		tmpStr = tmpStr + " " + hours + " heure";
		if (hours > 1) {
			tmpStr = tmpStr + "s";
		}
	}
	if (minutes > 0) {
		tmpStr = tmpStr + " " + Math.round(minutes) + " minute";
		if (minutes > 1) {
			tmpStr = tmpStr + "s";
		}
	}
	return tmpStr + " si la vitesse actuelle du bateau est maintenue, arrivée prévue le ";
}

function initArrays(what) {
	//debugger;
	if (what == "Bateau") {
		bateau = localStorage.getItem("Info bateau");
	} else if (what == "Etape") {
		if (etapeID >= 0) {
			var allText = localStorage.getItem("Info etape");
			if (allText != null) {
				if (etapeID > -1) {
					allEtapes = allText.split(rowStr);
				}
			}
		}
	} else if (what == "Journal") {
		var allText = localStorage.getItem("Journal");
		if (allText != null) {
			if (journalID > -1) {
				journal = allText.split(rowStr);
			}
		}
	} else if (what == "Equipage") {
		var allText = localStorage.getItem("Equipage");
		if (allText != null) {
			if (memberID > -1) {
				teamMember = allText.split(rowStr);
			}
		}
	}
}

function saveJournalFields() {
	journalFields = 0;
	//debugger;
	if (document.getElementById("offsetField").checked) { journalFields += 1; }
	if (document.getElementById("skyField").checked) { journalFields += 2; }
	if (document.getElementById("visibilityField").checked) { journalFields += 4; }
	if (document.getElementById("rainfallField").checked) { journalFields += 8; }
	if (document.getElementById("humidityField").checked) { journalFields += 16; }
	if (document.getElementById("windGustField").checked) { journalFields += 32; }
	if (document.getElementById("airTempField").checked) { journalFields += 64; }
	if (document.getElementById("waterTempField").checked) { journalFields += 128; }
	if (document.getElementById("depthField").checked) { journalFields += 256; }
	if (document.getElementById("speedField").checked) { journalFields += 512; }
	if (document.getElementById("courseField").checked) { journalFields += 1024; }
	if (document.getElementById("motorTimeField").checked) { journalFields += 2048; }
	if (document.getElementById("batteryVoltageField").checked) { journalFields += 4096; }
	if (document.getElementById("forecastField").checked) { journalFields += 8192; }
	depthLimit = document.getElementById("depthLimit").value;
	if (depthLimit == "") { depthLimit = 200; }
	saveGlobal();
	document.getElementById("infoSettings").innerHTML = "Les paramètres ont bien été sauvegardés.";
	journalElements();
}

function journalElements() {
	var what = journalFields;
	//debugger;
	if (what & 1) {
		document.getElementById("offsetJ").style.display = "";
		document.getElementById("offsetField").checked = true;
	} else {
		document.getElementById("offsetJ").style.display = "none";
		document.getElementById("offsetField").checked = false;
	}
	if (what & 2) {
		document.getElementById("skyJ").style.display = "";
		document.getElementById("skyField").checked = true;
	} else {
		document.getElementById("skyJ").style.display = "none";
		document.getElementById("skyField").checked = false;
	}
	if (what & 4) {
		document.getElementById("visibilityJ").style.display = "";
		document.getElementById("visibilityField").checked = true;
	} else {
		document.getElementById("visibilityJ").style.display = "none";
		document.getElementById("visibilityField").checked = false;
	}
	if (what & 8) {
		document.getElementById("rainfallJ").style.display = "";
		document.getElementById("rainfallField").checked = true;
	} else {
		document.getElementById("rainfallJ").style.display = "none";
		document.getElementById("rainfallField").checked = false;
	}
	if (what & 16) {
		document.getElementById("humidityJ").style.display = "";
		document.getElementById("humidityField").checked = true;
	} else {
		document.getElementById("humidityJ").style.display = "none";
		document.getElementById("humidityField").checked = false;
	}
	if (what & 32) {
		document.getElementById("windGustJ").style.display = "";
		document.getElementById("windGustField").checked = true;
	} else {
		document.getElementById("windGustJ").style.display = "none";
		document.getElementById("windGustField").checked = false;
	}
	if (what & 64) {
		document.getElementById("airJ").style.display = "";
		document.getElementById("airTempField").checked = true;
	} else {
		document.getElementById("airJ").style.display = "none";
		document.getElementById("airTempField").checked = false;
	}
	if (what & 128) {
		document.getElementById("waterJ").style.display = "";
		document.getElementById("waterTempField").checked = true;
	} else {
		document.getElementById("waterJ").style.display = "none";
		document.getElementById("waterTempField").checked = false;
	}
	if (what & 256) {
		document.getElementById("depthJ").style.display = "";
		document.getElementById("depthField").checked = true;
	} else {
		document.getElementById("depthJ").style.display = "none";
		document.getElementById("depthField").checked = false;
	}
	if (what & 512) {
		document.getElementById("speedJ").style.display = "";
		document.getElementById("speedField").checked = true;
	} else {
		document.getElementById("speedJ").style.display = "none";
		document.getElementById("speedField").checked = false;
	}
	if (what & 1024) {
		document.getElementById("courseJ").style.display = "";
		document.getElementById("courseField").checked = true;
	} else {
		document.getElementById("courseJ").style.display = "none";
		document.getElementById("courseField").checked = false;
	}
	if (what & 2048) {
		document.getElementById("motorJ").style.display = "";
		document.getElementById("motorTimeField").checked = true;
	} else {
		document.getElementById("motorJ").style.display = "none";
		document.getElementById("motorTimeField").checked = false;
	}
	if (what & 4096) {
		document.getElementById("batteryJ").style.display = "";
		document.getElementById("batteryVoltageField").checked = true;
	} else {
		document.getElementById("batteryJ").style.display = "none";
		document.getElementById("batteryVoltageField").checked = false;
	}
	if (what & 8192) {
		document.getElementById("forecastJ").style.display = "";
		document.getElementById("forecastField").checked = true;
	} else {
		document.getElementById("forecastJ").style.display = "none";
		document.getElementById("forecastField").checked = false;
	}
	//debugger;
	document.getElementById("depthLimit").value = depthLimit;
	document.getElementById("depthInMeters").innerHTML = "Profondeur (en mètres) si inférieure à " + depthLimit + "m :";
}

function mrHide(what) {
	screenChoice = what;
	if (what & 1) {
		document.getElementById("journalArea").style.display = "block";
		document.getElementById("butt1").style.background = "#E2F8FF";
	} else {
		document.getElementById("journalArea").style.display = "none";
		document.getElementById("butt1").style.background = "white";
	}
	if (what & 2) {
		document.getElementById("etapeArea").style.display = "block";
		document.getElementById("butt2").style.background = "#E2F8FF";
	} else {
		document.getElementById("etapeArea").style.display = "none";
		document.getElementById("butt2").style.background = "white";
	}
	if (what & 4) {
		document.getElementById("bateauArea").style.display = "block";
		document.getElementById("butt4").style.background = "#E2F8FF";
	} else {
		document.getElementById("bateauArea").style.display = "none";
		document.getElementById("butt4").style.background = "white";
	}
	if (what & 8) {
		document.getElementById("visuArea").style.display = "block";
		document.getElementById("butt8").style.background = "#E2F8FF";
	} else {
		document.getElementById("visuArea").style.display = "none";
		document.getElementById("butt8").style.background = "white";
	}
	if (what & 16) {
		document.getElementById("helpArea").style.display = "block";
		document.getElementById("butt16").style.background = "#E2F8FF";
	} else {
		document.getElementById("helpArea").style.display = "none";
		document.getElementById("butt16").style.background = "white";
	}
	if (what & 32) {
		document.getElementById("restoreArea").style.display = "block";
		document.getElementById("butt32").style.background = "#E2F8FF";
	} else {
		document.getElementById("restoreArea").style.display = "none";
		document.getElementById("butt32").style.background = "white";
	}
	if (what & 64) {
		document.getElementById("saveArea").style.display = "block";
		document.getElementById("butt64").style.background = "#E2F8FF";
	} else {
		document.getElementById("saveArea").style.display = "none";
		document.getElementById("butt64").style.background = "white";
	}
	if (what & 128) {
		document.getElementById("exportArea").style.display = "block";
		document.getElementById("butt128").style.background = "#E2F8FF";
	} else {
		document.getElementById("exportArea").style.display = "none";
		document.getElementById("butt128").style.background = "white";
	}
	if (what & 256) {
		document.getElementById("memberArea").style.display = "block";
		document.getElementById("butt256").style.background = "#E2F8FF";
	} else {
		document.getElementById("memberArea").style.display = "none";
		document.getElementById("butt256").style.background = "white";
	}
	if (what & 512) {
		document.getElementById("statisticArea").style.display = "block";
		document.getElementById("butt512").style.background = "#E2F8FF";
	} else {
		document.getElementById("statisticArea").style.display = "none";
		document.getElementById("butt512").style.background = "white";
	}
	if (what & 1024) {
		document.getElementById("settingArea").style.display = "block";
		document.getElementById("butt1024").style.background = "#E2F8FF";
	} else {
		document.getElementById("settingArea").style.display = "none";
		document.getElementById("butt1024").style.background = "white";
	}
	saveGlobal();
}

function getGlobalValues() {
	var allText = localStorage.getItem("Global variables");
	//debugger;
	if (allText != null) {
		var infoArray = allText.split(tabStr);
		etapeID = infoArray[0];
		journalID = infoArray[1];
		screenChoice = infoArray[2];
		memberID = infoArray[3];
		journalFields = infoArray[4];
		depthLimit = infoArray[5];
	} else {
		etapeID = -1;
		journalID = -1;
		memberID = -1;
		screenChoice = 16;
		journalFields = 16383;
		depthLimit = 200;
	}
	currentEtape = etapeID;
}

function initSelect(what) {
	var f, option, sortedList = [], x = document.getElementById(what);
    while (x.options.length > 0) {                
        x.remove(0);
    }
	option = document.createElement("option");  	
	option.text = "";
	option.value = -1;
	x.add(option);
	//debugger;
	for (f = 0; f <= memberID; ++f) {
		getMemberValues(f);
		sortedList[f] = memberFirst + " " + memberLast + "#" + memberNummerID;
	}
	sortedList.sort();
	for (f = 0; f <= memberID; ++f) {
		option = document.createElement("option");
		var tmpStr = sortedList[f];
		var tmpArr = tmpStr.split("#");
		option.text = tmpArr[0];
		option.value = tmpArr[1];
		x.add(option);
	}
}

function init() {
	//debugger;
	initPeople();
	getGlobalValues();
	mrHide(screenChoice);
	initArrays("Equipage");
	initSelect("captain");
	initSelect("memberEdit");
	initSelect("member1");
	initSelect("member2");
	initSelect("member3");
	initSelect("member4");
	initSelect("member5");
	initSelect("member6");
	initArrays("Bateau");
	if (bateau != null) {
		getBateauValues();
		document.getElementById("vesselName").value = vesselName;
		document.getElementById("vesselType").value = vesselType;
		document.getElementById("vesselModele").value = vesselModele;
		document.getElementById("vesselConstructeur").value = vesselConstructeur;
		document.getElementById("constructionDate").value = constructionDate;
		document.getElementById("francisationNumber").value = francisationNumber;
		document.getElementById("frenchizationAct").value = frenchizationAct;
		document.getElementById("regNumber").value = regNumber;
		document.getElementById("homeport").value = homeport;
		document.getElementById("navTitle").value = navTitle;
		document.getElementById("cinNumber").value = cinNumber;
		document.getElementById("mmsi").value = mmsi;
		document.getElementById("callSign").value = callSign;
		document.getElementById("vesselLength").value = vesselLength;
		document.getElementById("vesselWidth").value = vesselWidth;
		document.getElementById("vesselDraft").value = vesselDraft;
		document.getElementById("vesselWeight").value = vesselWeight;
		document.getElementById("vesselMotor").value = vesselMotor;
		document.getElementById("navZone").value = navZone;
		document.getElementById("conceptionCat").value = conceptionCat;
		document.getElementById("policeName").value = policeName;
		document.getElementById("policeNumber").value = policeNumber;
		document.getElementById("shipStationLicenseNumber").value = shipStationLicenseNumber;
		document.getElementById("shipStationLicenseValidUntil").value = shipStationLicenseValidUntil;
		document.getElementById("policeValidUntil").value = policeValidUntil;
		visuDisplayBateau();
	}
	//debugger;
	if (etapeID > -1) {
		initArrays("Etape");
		getEtapeValues(etapeID);
		document.getElementById("refStepJournal").value = refStepJournal;
		document.getElementById("stepDate").value = stepDate;
		document.getElementById("stepTime").value = stepTime;
		document.getElementById("pressureStep").value = pressureStep;
		document.getElementById("seaStep").value = seaStep;
		document.getElementById("windDirStep").value = windDirStep;
		document.getElementById("windForceStep").value = windForceStep;
		document.getElementById("captain").value = captain;
		document.getElementById("orig").value = orig;
		document.getElementById("latOrig").value = latOrig;
		document.getElementById("longOrig").value = longOrig;
		document.getElementById("dest").value = dest;
		document.getElementById("latDest").value = latDest;
		document.getElementById("longDest").value = longDest;
		document.getElementById("stepDescr").value = stepDescr;
		document.getElementById("member1").value = mb[0];
		document.getElementById("member2").value = mb[1];
		if (mb[1] != -1) { addPeople(1,2); }
		document.getElementById("member3").value = mb[2];
		if (mb[2] != -1) { addPeople(2,3); }
		document.getElementById("member4").value = mb[3];
		if (mb[3] != -1) { addPeople(3,4); }
		document.getElementById("member5").value = mb[4];
		if (mb[4] != -1) { addPeople(4,5); }
		document.getElementById("member6").value = mb[5];
		if (mb[5] != -1) { addPeople(5,6); }
		//debugger;
		visuDisplayEtape(etapeID);
	}
	if (journalID > -1) {
		initArrays("Journal");
		getJournalValues(journalID);
		visuDisplayJournal(etapeID);
		journalElements();
	}
	document.getElementById("versionInfo").innerHTML = "Logbook " + versionNumber + ", © Philippe Lagarrigue, novembre 2018, <a href='http://mikeno.fr/contact.html'>Contact</a>."
}

function saveGlobal() {
	if (typeof(Storage) !== "undefined") { // Check browser support
		var text = etapeID + tabStr + journalID + tabStr + screenChoice + tabStr + memberID + tabStr + journalFields + tabStr + depthLimit;
		localStorage.setItem("Global variables", text); // Store
	}
}

function saveInfoBateau() {
	vesselName = document.getElementById("vesselName").value;
	if (vesselName == "") {
		alert("Nom du navire manquant !");
		return;
	}
	vesselType = document.getElementById("vesselType").value;
	if (vesselType == "") {
		alert("Type du navire manquant !");
		return;
	}
	vesselModele = document.getElementById("vesselModele").value;
	if (vesselModele == "") {
		alert("Modèle du navire manquant !");
		return;
	}
	vesselConstructeur = document.getElementById("vesselConstructeur").value;
	if (vesselConstructeur == "") {
		alert("Indiquer le constructeur du navire !");
		return;
	}
	constructionDate = document.getElementById("constructionDate").value;
	if (constructionDate == "") {
		alert("Indiquer l'année de construction du navire !");
		return;
	}
	francisationNumber = document.getElementById("francisationNumber").value;
	if (francisationNumber == "") {
		alert("N° de francisation manquant");
		return;
	}
	frenchizationAct = document.getElementById("frenchizationAct").value;
	if (frenchizationAct == "") {
		alert("Quand l'acte de francisation a-t-il été délivré ?");
		return;
	}
	regNumber = document.getElementById("regNumber").value;
	if (regNumber == "") {
		alert("Immatriculation du navire manquante !");
		return;
	}
	homeport = document.getElementById("homeport").value;
	if (homeport == "") {
		alert("Indiquer le port d'attache !");
		return;
	}
	navTitle = document.getElementById("navTitle").value;
	if (navTitle == "") {
		alert("Quand le titre de navigation a-t-il été délivré ?");
		return;
	}
	cinNumber = document.getElementById("cinNumber").value;
	if (cinNumber == "") {
		alert("Indiquer le numéro CIN !");
		return;
	}
	shipStationLicenseNumber = document.getElementById("shipStationLicenseNumber").value;
	if (shipStationLicenseNumber == "") {
		alert("Licence de station de navire manquante !");
		return;
	}
	shipStationLicenseValidUntil = document.getElementById("shipStationLicenseValidUntil").value;
	if (shipStationLicenseValidUntil == "") {
		alert("Date de validité de la licence de station de navire manquante !");
		return;
	}
	mmsi = document.getElementById("mmsi").value;
	if (mmsi == "") {
		alert("MMSI du navire manquant !");
		return;
	}
	callSign = document.getElementById("callSign").value;
	if (callSign == "") {
		alert("Indicatif d'appel VHF du navire manquant !");
		return;
	}
	vesselLength = document.getElementById("vesselLength").value;
	if (vesselLength == "") {
		alert("Longueur du navire manquante !");
		return;
	}
	vesselWidth = document.getElementById("vesselWidth").value;
	if (vesselWidth == "") {
		alert("Largeur du navire manquante !");
		return;
	}
	vesselDraft = document.getElementById("vesselDraft").value;
	if (vesselDraft == "") {
		alert("Tirant d'eau du navire manquant !");
		return;
	}
	vesselWeight = document.getElementById("vesselWeight").value;
	if (vesselWeight == "") {
		alert("Poids du bateau manquant !");
		return;
	}
	vesselMotor = document.getElementById("vesselMotor").value;
	if (vesselMotor == "") {
		alert("Nombre de moteurs manquant !");
		return;
	}
	navZone = document.getElementById("navZone").value;
	if (navZone == "") {
		alert("Indiquer la zone de navigation !");
		return;
	}
	conceptionCat = document.getElementById("conceptionCat").value;
	if (conceptionCat == "") {
		alert("Indiquer la catégorie de conception !");
		return;
	}
	policeName = document.getElementById("policeName").value;
	if (policeName == "") {
		alert("Indiquer l'assurance du navire !");
		return;
	}
	policeNumber = document.getElementById("policeNumber").value;
	if (policeNumber == "") {
		alert("Le numéro de police d'assurance manque !");
		return;
	}
	policeValidUntil = document.getElementById("policeValidUntil").value;
	if (policeValidUntil == "") {
		alert("Date de validité de l'assurance manquante !");
		return;
	}
	//debugger;
	if (typeof(Storage) !== "undefined") { // Check browser support
		var text = vesselName + tabStr + vesselType + tabStr + regNumber + tabStr + mmsi + tabStr + callSign + tabStr + vesselLength + tabStr + vesselWidth + tabStr + vesselDraft + tabStr + vesselWeight + tabStr + navZone + tabStr + homeport + tabStr + navTitle + tabStr + frenchizationAct + tabStr + vesselModele + tabStr + vesselConstructeur + tabStr + constructionDate + tabStr + francisationNumber + tabStr + vesselMotor + tabStr + conceptionCat + tabStr + cinNumber + tabStr + policeName + tabStr + policeNumber + tabStr + shipStationLicenseNumber + tabStr + shipStationLicenseValidUntil + tabStr + policeValidUntil;
		localStorage.setItem("Info bateau", text); // Store
		document.getElementById("infoBateau").innerHTML = "Les infos de « " + vesselName + " » ont bien été enregistrées.";
		saveGlobal();
		visuDisplayBateau();
	} else {
		document.getElementById("infoBateau").innerHTML = "Désolé, votre navigateur ne convient pas pour la sauvegarde.";
	}
}

function saveMember() {
	//debugger;
	var memberNumID = document.getElementById("memberNummerID").value; // if != "" then it means that we edit this person
	memberFirst = document.getElementById("memberFirst").value;
	var firstName = memberFirst;
	if (memberFirst == "") {
		alert("Le prénom est manquant !");
		return;
	}
	memberLast = document.getElementById("memberLast").value;
	if (memberLast == "") {
		alert("Le nom est manquant !");
		return;
	}
	memberPseudo = document.getElementById("memberPseudo").value;
	memberSex = document.getElementById("memberSex").value;
	memberBirthday = document.getElementById("memberBirthday").value;
	if (memberBirthday == "") {
		alert("La date de naissance est manquante !");
		return;
	}
	memberCountry = document.getElementById("memberCountry").value;
	if (memberCountry == "") {
		alert("La nationalité est manquante !");
		return;
	}
	memberEmail = document.getElementById("memberEmail").value;
	if (memberCountry == "") {
		alert("L'adresse mail est manquante !");
		return;
	}
	debugger;
	memberRemark = document.getElementById("memberRemark").value;
	var text2save = memberFirst + tabStr + memberLast + tabStr + memberPseudo + tabStr + memberSex + tabStr + memberBirthday + tabStr + memberCountry + tabStr + memberEmail + tabStr + memberRemark.trim();
	if (memberID >= 0) { // This is to avoid saving the same information more than once
		getMemberValues(memberID);
		var text = memberFirst + tabStr + memberLast + tabStr + memberPseudo + tabStr + memberSex + tabStr + memberBirthday + tabStr + memberCountry + tabStr + memberEmail + tabStr + memberRemark.trim();
		if (text == text2save) {
			alert("Ces données ont déjà été sauvegardées !");
			return;
		}
	}
	if (memberNumID != "") {
		var f, allPeople = "", separator = "";
		text2save = memberNumID + tabStr + text2save;
		for (f = 0; f <= memberID; ++f) {
			//debugger;
			if (f == memberNumID) {
				allPeople = allPeople + separator + text2save;
			} else {
				allPeople = allPeople + separator + teamMember[f];
			}
			separator = rowStr;
		}
		if (typeof(Storage) !== "undefined") { // Check browser support
			localStorage.setItem("Equipage", allPeople); // Store
			document.getElementById("infoMember").innerHTML = "Les infos de " + firstName + " ont bien été modifiées.";
			saveGlobal();
			init();
		} else {
			document.getElementById("infoMember").innerHTML = "Désolé, votre navigateur ne convient pas pour la sauvegarde.";
		}
	} else {
		++memberID;
		memberNummerID = memberID;
		document.getElementById("memberNummerID").value = memberID;
		memberFirst = document.getElementById("memberFirst").value;
		if (typeof(Storage) !== "undefined") { // Check browser support
			var allText = localStorage.getItem("Equipage");
			if (allText == null) {
				localStorage.setItem("Equipage", memberID + tabStr + text2save); // Store
			} else {
				localStorage.setItem("Equipage", allText + rowStr + memberID + tabStr + text2save); // Store
			}
			document.getElementById("infoMember").innerHTML = "Les infos de " + firstName + " ont bien été enregistrées.";
			saveGlobal();
			init();
		} else {
			document.getElementById("infoMember").innerHTML = "Désolé, votre navigateur ne convient pas pour la sauvegarde.";
		}
	}
}

function saveStep() {
	var f, teamMember = "", count = 0;
	//debugger;
	if (typeof(vesselName) == "undefined") {
		alert("Remplir les informations du bateau avant de pouvoir continuer !");
		mrHide(4);
		return;
	}
	refStepJournal = document.getElementById("refStepJournal").value;
	stepDate = document.getElementById("stepDate").value;
	if (stepDate == "") {
		alert("La date de départ est manquante !");
		return;
	}
	stepTime = document.getElementById("stepTime").value;
	if (stepTime == "") {
		alert("L'heure de départ est manquante !");
		return;
	}
	
	pressureStep = document.getElementById("pressureStep").value;
	if (pressureStep == "") {
		alert("La pression atmosphérique est manquante !");
		return;
	}
	seaStep = document.getElementById("seaStep").value;
	if (seaStep == "") {
		alert("L'état de la mer est manquant !");
		return;
	}
	windDirStep = document.getElementById("windDirStep").value;
	if (windDirStep == "") {
		alert("La direction du vent est manquante !");
		return;
	}
	windForceStep = document.getElementById("windForceStep").value;
	if (windForceStep == "") {
		alert("La force du vent est manquante !");
		return;
	}
	
	orig = document.getElementById("orig").value;
	if (orig == "") {
		alert("Le nom du lieu de départ manque !");
		return;
	}
	latOrig = document.getElementById("latOrig").value;
	if (latOrig == "") {
		alert("La latitude du départ manque !");
		return;
	}
	if (coordinateOK(latOrig) == false) {
		alert("La latitude du départ est invalide !");
		return;
	}
	longOrig = document.getElementById("longOrig").value;
	if (longOrig == "") {
		alert("La longitude du départ manque !");
		return;
	}
	if (coordinateOK(longOrig) == false) {
		alert("La longitude du départ est invalide !");
		return;
	}
	dest = document.getElementById("dest").value;
	if (dest == "") {
		alert("Le nom de la destination manque !");
		return;
	}
	latDest = document.getElementById("latDest").value;
	if (latDest == "") {
		alert("La latitude de la destination est manquante !");
		return;
	}
	if (coordinateOK(latDest) == false) {
		alert("La latitude de la destination est invalide !");
		return;
	}
	longDest = document.getElementById("longDest").value;
	if (longDest == "") {
		alert("La longitude de la destination est manquante !");
		return;
	}
	if (coordinateOK(longDest) == false) {
		alert("La longitude de la destination est invalide !");
		return;
	}
	captain = document.getElementById("captain").value;
	if (captain == -1) {
		alert("Pas de chef de bord ?");
		return;
	}
	stepDescr = document.getElementById("stepDescr").value;
	for (f = 1; f < 7; ++f) {
		elem = "member" + f;
		mb[f-1] = document.getElementById(elem).value;
		if (mb[f-1] != -1) {
			teamMember += tabStr + mb[f-1];
			++count;
		}
	}
	teamMember = count + tabStr + teamMember;
	//debugger;
	var text2save = stepDate + tabStr + stepTime + tabStr + pressureStep + tabStr + seaStep + tabStr + windDirStep + tabStr + windForceStep + tabStr + captain + tabStr + orig + tabStr + latOrig + tabStr + longOrig + tabStr + dest + tabStr + latDest + tabStr + longDest + tabStr + stepDescr.trim() + tabStr + teamMember;
	if (etapeID >= 0) { // This is to avoid saving the same information more than once
		getEtapeValues(etapeID);
		count = 0;
		for (f = 0; f < 6; ++f) {
			if (mb[f] != -1) {
				teamMember += tabStr + mb[f];
				++count;
			}
		}
		teamMember = count + tabStr + teamMember;
		var text = stepDate + tabStr + stepTime + tabStr + pressureStep + tabStr + seaStep + tabStr + windDirStep + tabStr + windForceStep + tabStr + captain + tabStr + orig + tabStr + latOrig + tabStr + longOrig + tabStr + dest + tabStr + latDest + tabStr + longDest + tabStr + stepDescr.trim() + tabStr + teamMember;
		if (text == text2save) {
			alert("Ces données ont déjà été sauvegardées !");
			return;
		}
	}

	++etapeID; // = parseInt(etapeID) + 1;
	refStepJournal = etapeID;
	document.getElementById("refJournalStep").value = etapeID;
	document.getElementById("refStepJournal").value = refStepJournal;
	if (typeof(Storage) !== "undefined") { // Check browser support
		var allText = localStorage.getItem("Info etape");
		if (allText == null) {
			localStorage.setItem("Info etape", etapeID + tabStr + text2save); // Store
		} else {
			localStorage.setItem("Info etape", allText + rowStr + etapeID + tabStr + text2save); // Store
		}
		document.getElementById("infoStep").innerHTML = "Les infos de l'étape [" + refStepJournal + "] du " + formatDate(stepDate) + " à " + stepTime + " ont bien été enregistrées.";
		saveGlobal();
		init();
		// visuDisplayEtape(etapeID);
	} else {
		document.getElementById("infoStep").innerHTML = "Désolé, votre navigateur ne convient pas pour la sauvegarde.";
	}
}

function saveJournal() {
	var dateJournalPrevious, timeJournalPrevious, text, text2save = "";
	debugger;
	if (journalID > -1) { // Get date and time of the previous journal entry
		getJournalValues(journalID);
		if (refStepJournal != etapeID) {
			dateJournalPrevious = stepDate; // stepDate, stepTime
			timeJournalPrevious = stepTime;
		} else {
			dateJournalPrevious = dateJournal;
			timeJournalPrevious = timeJournal;
		}
	}
	if (etapeID < 0) {
		alert("Remplir les informations d'étape pour continuer !");
		mrHide(2);
		return;
	}
	refJournalStep = document.getElementById("refJournalStep").value;
	dateJournal = document.getElementById("dateJournal").value;
	if (dateJournal == "") {
		alert("La date est manquante !");
		return;
	}
	timeJournal = document.getElementById("timeJournal").value;
	if (timeJournal == "") {
		alert("L'heure est manquante !");
		return;
	}
	if (journalID > -1) { // Check first if date and time are later than for the previous journal entry
		//debugger;
		if (dateJournal < dateJournalPrevious) {
			alert("Veuiller corriger la date !");
			return;
		} else {
			if (dateJournal == dateJournalPrevious && timeJournal <= timeJournalPrevious) {
				alert("Veuiller corriger l'heure !");
				return;
			}
		}
	}
	timeOffsetH = document.getElementById("timeOffsetH").value;
	timeOffsetM = document.getElementById("timeOffsetM").value;
	forecastJournal = document.getElementById("forecastJournal").value;
	hygrometryJournal = document.getElementById("hygrometryJournal").value;
	pressureJournal = document.getElementById("pressureJournal").value;
	if (pressureJournal == "") {
		alert("La pression atmosphérique est manquante !");
		return;
	}
	skyJournal = document.getElementById("skyJournal").value;
	if (skyJournal == "") {
		alert("La description du ciel est manquante !");
		return;
	}
	visibilityJournal = document.getElementById("visibilityJournal").value;
	if (visibilityJournal == "") {
		alert("La visibilité est manquante !");
		return;
	}
	precipitationJournal = document.getElementById("precipitationJournal").value;
	seaJournal = document.getElementById("seaJournal").value;
	if (seaJournal == "") {
		alert("L'état de la mer est manquant !");
		return;
	}
	windDirJournal = document.getElementById("windDirJournal").value;
	if (windDirJournal == "") {
		alert("La direction du vent est manquante !");
		return;
	}
	windForceJournal = document.getElementById("windForceJournal").value;
	if (windForceJournal == "") {
		alert("La force du vent est manquante !");
		return;
	}
	windGustsJournal = document.getElementById("windGustsJournal").value;
	tempAirJournal = document.getElementById("tempAirJournal").value;
	tempWaterJournal = document.getElementById("tempWaterJournal").value;
	depthJournal = document.getElementById("depthJournal").value;
	lochSpeedJournal = document.getElementById("lochSpeedJournal").value;
	realSpeedJournal = document.getElementById("realSpeedJournal").value;
	compasCourseJournal = document.getElementById("compasCourseJournal").value;
	trueCourseJournal = document.getElementById("trueCourseJournal").value;
	latJournal = document.getElementById("latJournal").value;
	if (latJournal == "") {
		alert("La latitude est manquante !");
		return;
	}
	if (coordinateOK(latJournal) == false) {
		alert("La latitude est invalide !");
		return;
	}
	longJournal = document.getElementById("longJournal").value;
	if (longJournal == "") {
		alert("La longitude est manquante !");
		return;
	}
	if (coordinateOK(longJournal) == false) {
		alert("La longitude est invalide !");
		return;
	}
	motorJournal = document.getElementById("motorJournal").value;
	waterJournal = document.getElementById("waterJournal").value;
	gasJournal = document.getElementById("gasJournal").value;
	motorBatteryJournal = document.getElementById("motorBatteryJournal").value;
	batteriesJournal = document.getElementById("batteriesJournal").value;
	remarksJournal = document.getElementById("remarksJournal").value;
	debugger;
	var text2save = etapeID + tabStr + dateJournal + tabStr + timeJournal + tabStr + timeOffsetH + tabStr + timeOffsetM + tabStr + hygrometryJournal + tabStr + pressureJournal + tabStr + skyJournal + tabStr + visibilityJournal + tabStr + precipitationJournal + tabStr + seaJournal + tabStr + windDirJournal + tabStr + windForceJournal + tabStr + windGustsJournal + tabStr + tempAirJournal + tabStr + tempWaterJournal + tabStr + depthJournal + tabStr + lochSpeedJournal + tabStr + realSpeedJournal + tabStr + compasCourseJournal + tabStr + trueCourseJournal + tabStr + latJournal + tabStr + longJournal + tabStr + motorJournal + tabStr + waterJournal + tabStr + gasJournal + tabStr + motorBatteryJournal + tabStr + batteriesJournal + tabStr + remarksJournal.trim() + tabStr + forecastJournal;
	if (journalID >= 0) { // This is to avoid saving the same information more than once
		getJournalValues(journalID);
		text = etapeID + tabStr + dateJournal + tabStr + timeJournal + tabStr + timeOffsetH + tabStr + timeOffsetM + tabStr + hygrometryJournal + tabStr + pressureJournal + tabStr + skyJournal + tabStr + visibilityJournal + tabStr + precipitationJournal + tabStr + seaJournal + tabStr + windDirJournal + tabStr + windForceJournal + tabStr + windGustsJournal + tabStr + tempAirJournal + tabStr + tempWaterJournal + tabStr + depthJournal + tabStr + lochSpeedJournal + tabStr + realSpeedJournal + tabStr + compasCourseJournal + tabStr + trueCourseJournal + tabStr + latJournal + tabStr + longJournal + tabStr + motorJournal + tabStr + waterJournal + tabStr + gasJournal + tabStr + motorBatteryJournal + tabStr + batteriesJournal + tabStr + remarksJournal.trim() + tabStr + forecastJournal;
		if (text == text2save) {
			alert("Ces données ont déjà été sauvegardées !");
			return;
		}
	}

	//debugger;
	journalID = parseInt(journalID) + 1;
	text2save = journalID + tabStr + text2save;
	refJournalStep = journalID;
	document.getElementById("refJournalStep").value = etapeID;
	saveGlobal();
	if (typeof(Storage) !== "undefined") { // Check browser support
		var allText = localStorage.getItem("Journal");
		if (allText == null) {
			localStorage.setItem("Journal", text2save); // Store
		} else {
			localStorage.setItem("Journal", allText + rowStr + text2save); // Store
		}
		document.getElementById("infoJournal").innerHTML = "Les données de l'entrée numéro " + journalID + " du journal ont été enregistrées avec succès.";
		document.getElementById("journalID").value = journalID;
		saveGlobal();
		init();
		// visuDisplayJournal(etapeID);
	} else {
		document.getElementById("infoJournal").innerHTML = "Désolé, votre navigateur ne convient pas pour la sauvegarde.";
	}
}

function coordinateOK(latOrLong) {
	var deg, min, sec, dir;
	if (latOrLong.length == 11) { // 009-17-49-E (longitude)
		deg = latOrLong.slice(0, 3);
		if (deg < 0 || deg > 180) {
			return false;
		}
		min = latOrLong.slice(4, 6);
		sec = latOrLong.slice(7, 9);
		dir = latOrLong.slice(10, 11);
		if ("eowEOW".lastIndexOf(dir) == -1) {
			return false;
		}
	} else if (latOrLong.length == 10) { // 51-04-26-N (latitude)
		deg = latOrLong.slice(0, 2);
		if (deg < 0 || deg > 90) {
			return false;
		}
		min = latOrLong.slice(3, 5);
		sec = latOrLong.slice(6, 8);
		dir = latOrLong.slice(9, 10);
		if ("nsNS".lastIndexOf(dir) == -1) {
			return false;
		}
	}
	if (min < 0 || min > 60 || sec < 0 || sec > 60) {
		return false;
	}
	return true;
}

function getLastEntries() {
	//debugger;
	if (journalID >= 0) {
		getJournalValues(journalID);
		//document.getElementById("journalID").value = journalID;
		//document.getElementById("refJournalStep").value = refJournalStep;
		document.getElementById("dateJournal").value = dateJournal;
		document.getElementById("timeJournal").value = timeJournal;
		document.getElementById("timeOffsetH").value = timeOffsetH;
		document.getElementById("timeOffsetM").value = timeOffsetM;
		document.getElementById("forecastJournal").value = forecastJournal;
		document.getElementById("hygrometryJournal").value = hygrometryJournal;
		document.getElementById("pressureJournal").value = pressureJournal;
		document.getElementById("skyJournal").value = skyJournal;
		document.getElementById("visibilityJournal").value = visibilityJournal;
		document.getElementById("precipitationJournal").value = precipitationJournal;
		document.getElementById("seaJournal").value = seaJournal;
		document.getElementById("windDirJournal").value = windDirJournal;
		document.getElementById("windForceJournal").value = windForceJournal;
		document.getElementById("windGustsJournal").value = windGustsJournal;
		document.getElementById("tempAirJournal").value = tempAirJournal;
		document.getElementById("tempWaterJournal").value = tempWaterJournal;
		document.getElementById("depthJournal").value = depthJournal;
		document.getElementById("lochSpeedJournal").value = lochSpeedJournal;
		document.getElementById("realSpeedJournal").value = realSpeedJournal;
		document.getElementById("compasCourseJournal").value = compasCourseJournal;
		document.getElementById("trueCourseJournal").value = trueCourseJournal;
		document.getElementById("latJournal").value = latJournal;
		document.getElementById("longJournal").value = longJournal;
		document.getElementById("motorJournal").value = motorJournal;
		document.getElementById("waterJournal").value = waterJournal;
		document.getElementById("gasJournal").value = gasJournal;
		document.getElementById("motorBatteryJournal").value = motorBatteryJournal;
		document.getElementById("batteriesJournal").value = batteriesJournal;
		document.getElementById("remarksJournal").value = remarksJournal;
	}
}

function exportData() {
	var filename = "LogBook_" + versionNumber + ".txt";
	var dataText; // = "Exécuter les 4 commandes suivantes dans la console de votre navigateur pour exporter vos données :\n\n"
	var nextStr = String.fromCharCode(6);
	//debugger;
	dataText = "Global variables" + sepStr + localStorage.getItem('Global variables') + nextStr;
	dataText = dataText + "Equipage" + sepStr + localStorage.getItem('Equipage') + nextStr;
	dataText = dataText + "Info bateau" + sepStr + localStorage.getItem('Info bateau') + nextStr;
	dataText = dataText + "Info etape" + sepStr + localStorage.getItem('Info etape') + nextStr;
	dataText = dataText + "Journal" + sepStr + localStorage.getItem('Journal') + nextStr;
	var blob = new Blob([dataText], {
		type: "text/plain;charset=utf-8"
	});
	saveAs(blob, filename);
}

function importData() {
	if (confirm("Toutes les données actuelles vont être effacées, cliquer OK pour continuer")) {
		var nextStr = String.fromCharCode(6);
		var allData = document.getElementById("importValues").value;
		var infoAll = allData.split(nextStr);
		var f, tmpArray = [];
		//debugger;
		for (f = 0; f < 5; f++) {
			allData = infoAll[f];
			tmpArray = allData.split(sepStr);
			localStorage.setItem(tmpArray[0], tmpArray[1]);
		}
		init();
		document.getElementById("importResult").innerHTML = "Import terminé";
	}
}

function numberOfMinutes(time1, time2) {
	var minutes1, minutes2;
	if (time1 < time2) { // (00:00, 12:16)
		minutes1 = parseInt(time1.slice(0, 2)) * 60 + parseInt(time1.slice(3, 5));
		minutes2 = parseInt(time2.slice(0, 2)) * 60 + parseInt(time2.slice(3, 5));
	} else { // (12:16, 00:00)
		minutes2 = (parseInt(time2.slice(0, 2)) + 24) * 60 + parseInt(time2.slice(3, 5));
		minutes1 = parseInt(time1.slice(0, 2)) * 60 + parseInt(time1.slice(3, 5));
	}
	return minutes2 - minutes1;
}

function exportKmlData() {
	if (journalID == -1) {
		alert("Il n'y a aucune donnée à exporter !");
		return;
	}
	var filename = "LogBook.kml", etapeNum = -1;
	var journalNum, longitude, latitude, kml, tab1 = tabStr,
		tab2 = tab1 + tab1,
		tab3 = tab2 + tab1,
		tab4 = tab2 + tab2;
	kml = "<?xml version='1.0' encoding='UTF-8'?>\n<kml xmlns='http://www.opengis.net/kml/2.2'>\n" + "<Document>\n" + tab1 + "<name>Trajet Mike No</name>\n";
	for (journalNum = 0; journalNum <= journalID; ++journalNum) {
		getJournalValues(journalNum);
		if (refJournalStep != etapeNum) {
			if (etapeNum != -1) {
				kml += "\n" + tab3 + "</coordinates>\n" + tab2 + "</LineString>\n" + tab1 + "</Placemark>\n";
			}
			etapeNum = refJournalStep;
			getEtapeValues(etapeNum);
			kml += tab1 + "<Placemark>\n" + tab2 + "<name>" + orig + " -> " + dest + "</name>\n" + tab2 + "<description>" + stepDescr + "</description>\n" + tab2 + "<LineString>\n" + tab3 + "<coordinates>\n" + tab4;
			latitude = dms2Dec(latOrig);
			longitude = dms2Dec(longOrig);
			kml += longitude + "," + latitude + ",0 ";
		}
		latitude = dms2Dec(latJournal);
		longitude = dms2Dec(longJournal);
		kml += longitude + "," + latitude + ",0 ";
	}
	kml += "\n" + tab3 + "</coordinates>\n" + tab2 + "</LineString>\n" + tab1 + "</Placemark>\n";
	kml += "</Document>\n</kml>\n";
	var blob = new Blob([kml], {
		type: "text/plain;charset=utf-8"
	});
	saveAs(blob, filename);
}

function exportCsvData() {
	if (journalID == -1) {
		alert("Il n'y a aucune donnée à exporter !");
		return;
	}
	var journalNum, etapeNum = -1, captainName;
	var filename = "LogBook.csv", csv ="Nom du navire," + vesselName + "\nType," + vesselType + "\nModèle," + vesselModele + " (" + vesselConstructeur + ")\nLongueur / Largeur / Tirant d'eau / Déplacement," + vesselLength + "m / " + vesselWidth + "m / " + vesselDraft + "m / " + vesselWeight + "t\nN° d'immatriculation," + regNumber + "\nN° de francisation," + francisationNumber + " (" + formatDate(frenchizationAct) + ")\nTitre de navigation délivré le " + formatDate(navTitle) + "\nNuméro CIN,"  + cinNumber + "Port d'attache," + homeport + "\nLicence de station de navire N° " + shipStationLicenseNumber + " valable jusqu'au " + formatDate(shipStationLicenseValidUntil) + "\nMMSI," + mmsi + "\nIndicatif d'appel VHF," + callSign + "\nÉquipé pour une navigation de type," + navChoice[navZone] + "\nCatégorie de conception," + conceptionChoice[conceptionCat] + "\nAssurance," + policeName + " (N° " + policeNumber + ")\n\n";
	csv += "Étape,Date,Heure,Time offset,Prévisions,Hygrométrie,Press. atm.,Ciel,Visibilité,Precip.,Mer,Dir. du vent,Force du vent,Raffales,Temp. air,Temp. eau,Prof.,Vit. loch,Vit. GPS,Cap comp.,Cap vrai,Latitude,Longitude,Heures mot.,Quant. rest. eau,Quant. rest. GO,Batt. mot.,Batt. serv.,Remarques\n";
	for (journalNum = 0; journalNum <= journalID; ++journalNum) {
		getJournalValues(journalNum);
		if (refJournalStep != etapeNum) {
			//debugger;
			getEtapeValues(refJournalStep);
			getMemberValues(captain);
			captainName = memberFirst + "&nbsp;" + memberLast;
			var f;
			for (f = 0; f < 6; ++f) {
				if (mb[f] != -1) {
					getMemberValues(mb[f]);
					captainName += ", " + memberFirst + "&nbsp;" + memberLast;
				}
			}
			etapeNum = refJournalStep;
			csv += etapeNum + "," + formatDate(stepDate) + "," + stepTime + ",,,," + pressureStep + ",,,," + seaChoice[seaStep] + "," + windDirStep + "," + windForceStep + ",,,,,,,,," + latOrig + "," + longOrig + ",,,,,,\"" + orig + "->" + dest + ", à bord : " + captainName + ". " + stepDescr + "\"\n";
		}
		if (depthJournal == "") {
			depthJournal = ">" + depthLimit;
		}
		csv += "," + formatDate(dateJournal) + "," + timeJournal + "," + timeOffsetH + ":" + timeOffsetM + "," + forecastJournal + "," + hygrometryJournal + "," + pressureJournal + "," + skyJournal + "," + visibilityChoice[visibilityJournal] + "," + precipitationChoice[precipitationJournal] + "," + seaChoice[seaJournal] + "," + windDirJournal + "°," + windForceJournal + "," + windGustsJournal + "," + tempAirJournal + "," + tempWaterJournal + "," + depthJournal + "," + lochSpeedJournal + "," + realSpeedJournal + "," + compasCourseJournal + "," + trueCourseJournal + "," + latJournal + "," + longJournal + "," + motorJournal + "," + waterJournal + "," + gasJournal + "," + motorBatteryJournal + "," + batteriesJournal + ",\"" + remarksJournal + "\"\n";
	}
	var blob = new Blob([csv], {
		type: "text/plain;charset=utf-8"
	});
	saveAs(blob, filename);
}

function exportHtmlData() {
	if (journalID == -1) {
		alert("Il n'y a aucune donnée à exporter !");
		return;
	}
	//debugger;
	var journalNum, etapeNum = -1, captainName;
	var expWin = window.open("about:blank", "Logbook", "resizable='yes'");
	var html = "<html lang='fr'><head><meta http-equiv='Content-Type' content='text/html; charset=utf-8'><title>Journal de bord - Export</title><style type='text/css'>#nice{font-family:Verdana;font-size:0.84em;border-collapse:collapse;} #nice td,#nice th{border:1px solid #ddd;} #nice tr:nth-child(even){background-color: #f2f2f2;} #nice th {vertical-align:top;text-align:left;background-color: #2f438e;color: white;} #nice tr:hover {background-color: #2f438e; color: white;}</style></head><body style=font-family:'Verdana';font-size:0.74em;line-height:140%;color:black;>";
	html += "<p>Nom du navire : « <strong>" + vesselName + "</strong> »<br>Type : « " + vesselType + " »<br>Modèle : « " + vesselModele + " » (" + vesselConstructeur + ")<br>Longueur / Largeur / Tirant d'eau / Déplacement : " + vesselLength + " m / " + vesselWidth + " m / " + vesselDraft + " m / " + vesselWeight + " t<br>Nombre de moteurs : " + vesselMotor + "<br>N° d'immatriculation : « " + regNumber + " »<br> N° de francisation : « " + francisationNumber + " » délivré le " + formatDate(frenchizationAct) + "<br>Titre de navigation délivré le " + formatDate(navTitle) + "<br>Numéro CIN : "  + cinNumber + "<br>Port d'attache : " + homeport + "<br>Licence de station de navire N° " + shipStationLicenseNumber + " valable jusqu'au " + formatDate(shipStationLicenseValidUntil) + "<br>MMSI : « " + mmsi + " », Indicatif d'appel VHF : « " + callSign + " »<br>Équipé pour une navigation de type : " + navChoice[navZone] + "<br>Catégorie de conception : " + conceptionChoice[conceptionCat] + "<br>Assurance : " + policeName + " (N° " + policeNumber + ") valable jusqu'au " + formatDate(policeValidUntil) + "</p><table id='nice'>";
	html += "<tr><th>Date</th><th>Heure</th><th>Time<br>offset</th><th>Météo</th><th>Hygro</th><th>Press.<br>atm.<br>(hPa)</th><th>Ciel</th><th>Visibilité</th><th>Précip.</th><th>Mer</th><th>Dir.<br>du<br>vent</th><th>Force<br>du<br>vent en<br>nœuds</th><th>Raff. en<br>nœuds</th><th>Temp.<br>air<br>en ° C.</th><th>Temp.<br>eau<br>en ° C.</th><th>Prof.<br>en m</th><th>Vit.<br>loch en<br>nœuds</th><th>Vit.<br>GPS en<br>nœuds</th><th>Cap<br>comp.</th><th>Cap<br>vrai</th><th>Latitude</th><th>Longitude</th><th>Heures<br>mot.</th><th>Quant.<br>rest.<br>eau</th><th>Quant.<br>rest.<br>GO</th><th>Batt.<br>mot.<br>(Volt)</th><th>Batt.<br>serv.<br>(Volt)</th><th>Remarques</th></tr>";
	for (journalNum = 0; journalNum <= journalID; ++journalNum) {
		getJournalValues(journalNum);
		if (refJournalStep != etapeNum) {
			getEtapeValues(refJournalStep);
			getMemberValues(captain);
			people = memberFirst + "&nbsp;" + memberLast;
			var f;
			//debugger;
			for (f = 0; f < 6; ++f) {
				if (mb[f] != -1) {
					getMemberValues(mb[f]);
					people += ", " + memberFirst + "&nbsp;" + memberLast;
				}
			}
			etapeNum = refJournalStep;
			//getEtapeValues(etapeNum);
			html += "<tr><td>" + formatDate(stepDate) + "</td><td>" + stepTime + "<td></td></td><td></td><td></td><td>" + pressureStep + "</td><td colspan='3'><strong>" + orig + "->" + dest + "</strong></td><td>" + seaChoice[seaStep] + "</td><td>" + windDirStep + "°</td><td>" + windForceStep + "</td><td colspan='8'>À bord : " + people + "</td><td>" + latOrig + "</td><td>" + longOrig + "</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>Départ de " + orig + ". " + stepDescr + "</td></tr>";
		}
		if (depthJournal == "") {
			depthJournal = ">" + depthLimit;
		}
		html += "<tr><td>" + formatDate(dateJournal) + "</td><td>" + timeJournal + "</td><td>" + timeOffsetH + ":" + timeOffsetM + "</td><td>" + forecastJournal + "</td><td>" + hygrometryJournal + "</td><td>" + pressureJournal + "</td><td>" + skyJournal + "</td><td>" + visibilityChoice[visibilityJournal] + "</td><td>" + precipitationChoice[precipitationJournal] + "</td><td>" + seaChoice[seaJournal] + "</td><td>" + windDirJournal + "°</td><td>" + windForceJournal + "</td><td>" + windGustsJournal + "</td><td>" + tempAirJournal + "</td><td>" + tempWaterJournal + "</td><td>" + depthJournal + "</td><td>" + lochSpeedJournal + "</td><td>" + realSpeedJournal + "</td><td>" + compasCourseJournal + "</td><td>" + trueCourseJournal + "</td><td>" + latJournal + "</td><td>" + longJournal + "</td><td>" + motorJournal + "</td><td>" + waterJournal + "</td><td>" + gasJournal + "</td><td>" + motorBatteryJournal + "</td><td>" + batteriesJournal + "</td><td>" + remarksJournal + "</td></tr>";
	}
	html += "</table></body></html>";
	expWin.document.open();
	expWin.document.write(html);
	expWin.document.close();
}

function dayHoursMinutes(minutes) {
	var retStr = "";
	var days = parseInt(minutes / 1440);
	minutes = minutes - days * 1440;
	var hours = parseInt(minutes / 60);
	minutes = minutes - hours * 60;
	retStr = "";
	if (days > 0) {
		retStr += days + " jours ";
	}
	if (hours > 0) {
		retStr += hours + " heures ";
	}
	if (minutes > 0) {
		retStr += minutes + " minutes";
	}
	return retStr;
}

function statistics() {
	if (journalID == -1) {
		alert("Il n'y a aucune donnée !");
		return;
	}
	var etapeTime, etapeMiles, maxStepTime = 0, maxStepMiles = 0, totalTime = 0, totalMiles = 0;
	var ref = [], miles = [], dat = [], tim = [], min = [];
	var tmpStr, stepMilesInfo, stepTimeInfo, speedInfo, maxKnots = 0, knots, days, hours, minutes, dist, lat, long, previousLat, previousLong, journalNum, count = 0, etapeNum = -1;
	for (journalNum = 0; journalNum <= journalID; ++journalNum) {
		getJournalValues(journalNum);
		if (refJournalStep != etapeNum) {
			if (etapeMiles > maxStepMiles) {
				maxStepMiles = etapeMiles;
				stepMilesInfo = "<strong>" + Math.round(etapeMiles) + " miles</strong> lors de l'étape " + orig + "->" + dest + ".";
			}
			if (etapeTime > maxStepTime) {
				maxStepTime = etapeTime;
				tmpStr = "<strong>" + dayHoursMinutes(etapeTime) + "</strong>";
				stepTimeInfo = tmpStr + " lors de l'étape " + orig + "->" + dest + ".";
			}
			getEtapeValues(refJournalStep);
			etapeNum = refJournalStep;
			previousLat = dms2Dec(latOrig);
			previousLong = dms2Dec(longOrig);
			dat[count] = stepDate;
			tim[count] = stepTime;
			miles[count] = "";
			min[count] = "";
			ref[count++] = etapeNum + ",";
			etapeTime = 0;
			etapeMiles = 0;
		}
		lat = dms2Dec(latJournal);
		long = dms2Dec(longJournal);
		dist = orthodromy(previousLat, previousLong, lat, long);
		miles[count] = dist.toFixed(2);
		previousLat = lat;
		previousLong = long;
		dat[count] = dateJournal;
		tim[count] = timeJournal;
		minutes = numberOfMinutes(tim[count-1], tim[count]);
		min[count] = minutes;
		totalTime += minutes;
		totalMiles += dist;
		etapeTime += minutes;
		etapeMiles += dist;
		knots = dist / minutes * 60;
		if (knots > maxKnots) { // Speed record
			maxKnots = knots;
			hours = parseInt(minutes / 60);
			minutes = minutes - hours * 60;
			if (dat[count - 1] == dat[count]) {
				tmpStr = "le " + formatDate(dat[count - 1]) + " entre " + tim[count - 1] + " et " + tim[count];
			} else {
				tmpStr = "entre le " + formatDate(dat[count - 1]) + " à " + tim[count - 1] + " et le " + formatDate(dat[count]) + " à " + tim[count];
			}
			speedInfo = "<strong>" + knots.toFixed(2) + " nœuds</strong> de moyenne " + tmpStr + " pendant l'étape " + orig + "->" + dest + ", soit " + dist.toFixed(2) + " milles en " + hours + "h "+ minutes + " minutes.";
		}
		ref[count++] = etapeNum + "," + journalNum;
	}
	document.getElementById("speedRecord").innerHTML = speedInfo;
	document.getElementById("biggestDuration").innerHTML = stepTimeInfo;
	document.getElementById("biggestDistance").innerHTML = stepMilesInfo;
	document.getElementById("totalTime").innerHTML = "<strong>" + dayHoursMinutes(totalTime) + "</strong>.";
	document.getElementById("totalDistance").innerHTML = "<strong>" + Math.round(totalMiles) + " milles</strong>.";
	knots = totalMiles / totalTime * 60;
	count = knots * 24;
	document.getElementById("averageSpeed").innerHTML = "<strong>" + knots.toFixed(2) + " nœuds</strong> soit une moyenne de " + Math.round(count) + " milles par 24h.";
	//debugger;
	var firstTime, firstDate, f, best24Info;
	maxStepMiles = 0;
	for (journalNum = 0; journalNum <= journalID; ++journalNum) {
		firstTime = tim[journalNum];
		firstDate = dat[journalNum];
		totalMiles = 0.0;
		totalTime = 0.0;
		for (f = journalNum + 1; f <= journalID; ++f) {
			totalMiles += parseFloat(miles[f]);
			totalTime += parseFloat(min[f]);
			if (dat[f] != firstDate && tim[f] >= firstTime) {
				etapeMiles = totalMiles / totalTime * 1440;
				if (etapeMiles > maxStepMiles) {
					maxStepMiles = etapeMiles;
					getEtapeValues(parseInt(ref[f]));
					knots = etapeMiles / 24;
					best24Info = "<strong>" + Math.round(etapeMiles) + " milles</strong> du " + formatDate(firstDate) + " à " + firstTime + " au " + formatDate(dat[f]) + " à " + firstTime + " lors de l'étape " + orig + "->" + dest + " à " + knots.toFixed(2) + " nœuds de moyenne.";
				}
				//debugger;
				break;
			}
		}
	}
	document.getElementById("biggestDistance24").innerHTML = best24Info;
	var etapes = parseInt(etapeID) + 1, membres = parseInt(memberID) + 1, entrees = parseInt(journalID) + 1;
	document.getElementById("statistics").innerHTML = "Le journal de bord contient actuellement " + etapes + " étapes, " + membres + " membres d'équipage et " + entrees + " entrées.";
}

function deDe() {
	document.getElementById("orig").value = document.getElementById("dest").value;
	document.getElementById("dest").value = "";
	document.getElementById("latOrig").value = document.getElementById("latDest").value;
	document.getElementById("latDest").value = "";
	document.getElementById("longOrig").value = document.getElementById("longDest").value;
	document.getElementById("longDest").value = "";
}
